
QGIS Application - Bug report #15273

Geopackage layer extent wrong

2016-07-13 09:22 AM - Giovanni Manghi

Status: Closed

Priority: Normal

Assignee: Even Rouault

Category: Data Provider/OGR

Affected QGIS version:2.16.0 Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 23209

Description

    -  Create a geopackage db/layer from scratch, polygon for example.

    -  add a few feature, save edits

    -  zoom to layer > o far so good

    -  edit the layer removing feature(s) (at least one near the bbox of the layer)

    -  save edits

    -  zoom to layer > extent is wrong, as if the deleted feature are still there

    -  "update extent" does nothing, as also rmeoving/adding the layer again, or closing QGIS

Associated revisions

Revision 70ae3013 - 2016-10-18 03:03 PM - Even Rouault

[OGR provider] Update layer extent for GPKG layers

When moving or deleting a geometry that previously touched the layer extent,

the layer extent was never shrinked.

This fix requires GDAL 2.1.2 or above as well.

Fixes #15273

Revision 9d316b01 - 2016-10-18 03:22 PM - Even Rouault

[OGR provider] Update layer extent for GPKG layers

When moving or deleting a geometry that previously touched the layer extent,

the layer extent was never shrinked.

This fix requires GDAL 2.1.2 or above as well.

Fixes #15273

Revision d2299c1f - 2016-10-18 04:01 PM - Even Rouault

[OGR provider] Update layer extent for GPKG layers

When moving or deleting a geometry that previously touched the layer extent,
the layer extent was never shrinked.

This fix requires GDAL 2.1.2 or above as well.

Fixes #15273

Revision 70186ee2 - 2016-10-18 04:23 PM - Even Rouault

[OGR provider] Update layer extent for GPKG layers

When moving or deleting a geometry that previously touched the layer extent,

the layer extent was never shrinked.

This fix requires GDAL 2.1.2 or above as well.

Fixes #15273

History

#1 - 2016-09-05 10:30 AM - Even Rouault

The layer extent is stored in the gpkg_contents system table, but the extent can only grow. If it shrinks, a full rescan of the whole layer should be done to

recompute it.

#2 - 2016-09-05 12:39 PM - Giovanni Manghi

Even Rouault wrote:

The layer extent is stored in the gpkg_contents system table, but the extent can only grow. If it shrinks, a full rescan of the whole layer should be

done to recompute it.

Is this considered an upstream (format?) bug... or feature?

#3 - 2016-10-05 03:34 PM - Even Rouault

It is a feature shared by all formats that save an extent in their metadata (shapefiles have the same issues, unless you compact them). There's no fast way

to update the layer extent when updating or removing features, apart from rescanning the whole layer. So of course this can be forced (would probably

make sense in being implement by a special SQL command in the OGR GeoPackage driver), and could be likely done at the end of an edit session.

#4 - 2016-10-18 06:06 AM - Even Rouault

- Status changed from Open to Closed

Fixed in changeset commit:"70ae301310c7a58134ac699fae70af7fd1176684".

#5 - 2016-10-19 12:32 PM - Even Rouault

- Target version set to Version 2.14
- Category changed from Vectors to Data Provider/OGR

- Assignee set to Even Rouault

Fix requires GDAL 2.1.2 or later to work
